/**
 * Implements the MyQueue interface by using a MyLinkedList list
 * to store the queue items.
 *
 * @author <your name here>
 * @version <your version here>
 */
public class MyQueueMyLinkedList<E> implements MyQueue<E>{

    // make a new linkedlist object 
    MyLinkedList<E> list = new MyLinkedList<E>();   

    // MyQueue methods
    
    // same as add
    public boolean enqueue(E elem){ 
        list.add(elem);
        return true;
    }
    
    
    // same as remove
    public E dequeue(){
        E retval = null;
        if (list.size() > 0) 
            retval = list.remove(0); 
        return retval;
    }
    
    /**
     * Adds a new element to the queue.
     * 
     * @param elem the element to be added.
     * @return true if the collection changed as a result of this addition;
     * false otherwise.
     */
    public boolean add(E elem){ 
        // adding to the END
        list.add(elem);
        return true;
    }

    /**
     * Removes the next item to be removed from the queue, 
     * according to its removal rule.
     * 
     * @return the item removed, or null if queue is empty.
     */
    public E remove(){
        E retval = null;
        // check that list isn't empty
        if (list.size() > 0) 
            // removing from the FRONT
            retval = list.remove(0); 
        return retval;
    } 

    /**
     * Retrieves the next item to be removed from the queue, 
     * according to its removal rule, without actually removing it.
     * 
     * @return the next item to be removed, or null if queue is empty.
     */    
    public E peek(){
        E retval = null;
        // check that list isn't empty
        if (list.size() > 0) 
            // get element but don't remove it 
            retval = list.get(0); 
        return retval;
    }

    // MyCollection methods from here on out
    /**
     * Returns the number of elements currently in the collection.
     *
     * @return the number of elements in the collection.
     */
    public int size(){ 
       return list.size();
    }

    /**
     * Removes an element from the collection.
     *
     * @param elem the element to be removed from the collection.
     * @return true if the collection changed as a result of this addition, false otherwise.
     */
    public boolean remove(E elem) {
       // need to do it this way for our tests to pass
       return list.remove(elem); 
    }

    /**
     * Checks whether the element passed as an argument is present in the collection.
     *
     * @param elem the element whose presence is to be tested.
     * @return true if the element is present in the collection; false otherwise.
     */
    public boolean contains(E elem){
        return list.contains(elem);
    }

    /**
     * Returns an iterator that lets traverse the collection.
     *
     * @return an iterator object associated with the collection.
     */
    public MyIterator<E> iterator(){
        return list.iterator();
    }

}
