/**
 * Implements the MyStack interface by using a MyLinkedList list
 * to store the stack items.
 *
 * @author <your name here>
 * @version <your version here>
 */
public class MyStackMyLinkedList<E> implements MyStack<E>{

    // your fields here
    MyLinkedList<E> list = new MyLinkedList<E>();

    // MyStack methods

    // copy of add method 
    public boolean push(E elem) {
        list.add(0,elem);
        return true;
    }

    // copy of remove method
    public E pop() {
        E retval = null;
        if (list.size() > 0) 
            retval = list.remove(0);
        return retval;

    }
    /**
     * Adds a new element to the stack.
     * 
     * @param elem the element to be added.
     * @return true if the collection changed as a result of this addition;
     * false otherwise.
     */
    public boolean add(E elem){ 
        // add to FRONT
        list.add(0,elem); 
        return true;
    }

    /**
     * Removes the next item to be removed from the stack, 
     * according to its removal rule.
     * 
     * @return the item removed, or null if stack is empty.
     */
    public E remove(){
        E retval = null;
        // remove from FRONT
        if (list.size() > 0) 
            retval = list.remove(0);
        return retval;
    } 

    /**
     * Retrieves the next item to be removed from the stack, 
     * according to its removal rule, without actually removing it.
     * 
     * @return the next item to be removed, or null if stack is empty.
     */    
    public E peek(){
        E retval = null;
        // get element but don't remove it 
        if (list.size() > 0) 
            retval = list.get(0); 
        return retval;
    }

    // MyCollection methods from here on out
    /**
     * Returns the number of elements currently in the collection.
     *
     * @return the number of elements in the collection.
     */
    public int size(){ 
        return list.size();
    }

    /**
     * Removes an element from the collection.
     *
     * @param elem the element to be removed from the collection.
     * @return true if the collection changed as a result of this addition, false otherwise.
     */
    public boolean remove(E elem){
        // need to do it this way so that our tests pass
        return list.remove(elem);
    }

    /**
     * Checks whether the element passed as an argument is present in the collection.
     *
     * @param elem the element whose presence is to be tested.
     * @return true if the element is present in the collection; false otherwise.
     */
    public boolean contains(E elem){
        return list.contains(elem);
    }

    /**
     * Returns an iterator that lets traverse the collection.
     *
     * @return an iterator object associated with the collection.
     */
    public MyIterator<E> iterator(){
        return list.iterator();
    }

}
